#!/usr/bin/env python
#coding:utf-8
import gtk
import pplive
import os
import time
import user
import gobject
import re

class main_window(gtk.Window):
    def quit(self, w):
        os.system('killall mplayer')
        os.system('killall xpplive')
        gtk.main_quit()

    def __init__(self, parent=None, totem=None):
        self.totem = totem
        gtk.Window.__init__(self)
        try:
            self.set_screen(parent.get_screen())
        except AttributeError:
            self.connect('destroy', self.quit)

        self.set_border_width(5)
        self.d = pplive.test()
        m = []
        for i,ii in self.d.items():
            m.append(i)

        menu = self.__create_option_menu(m)
        menu.connect('changed', self.catalog_change)
        h = gtk.HBox()
        h.add( menu)
        update = gtk.Button('刷新')
        update.connect('clicked', self.update)
        h.pack_start( update, expand=False)

        self.model, sw, tv= self.setTreeView()

        v = gtk.VBox(); v.set_border_width(5)
        v.pack_start( h, expand=False)
        v.add( sw)
        self.label = gtk.Label('正在播放：')
        h = gtk.HBox()
        h.pack_start( self.label)


        tooltips = gtk.Tooltips()
        b = gtk.Button()
        tooltips.set_tip(b, '停止后台运行的xpplive程序。')
        i = gtk.Image()
        i.set_from_stock('gtk-media-stop',gtk.ICON_SIZE_BUTTON)
        b.add( i)
        b.connect('clicked',self.quit)
        h.pack_end( b, expand=False)

        b = gtk.Button()
        tooltips.set_tip(b, '打开http://127.0.0.1:1024/1.asf位置播放。因为有时候会自己停止播放！')
        i = gtk.Image()
        i.set_from_stock('gtk-media-play',gtk.ICON_SIZE_BUTTON)
        b.add( i)
        b.connect('clicked', self.play)
        h.pack_end( b, expand=False)

        v.pack_start( h, expand=False)

        tab = gtk.Notebook()
        tab.append_page( child=v, tab_label= gtk.Label('频道'))

        v = gtk.VBox(); v.set_border_width(5)
        h = gtk.HBox()
        b = gtk.Button('加入收藏')
        b.connect('clicked', self.jrsc)
        tooltips.set_tip(b, '将正在播放的频道加入收藏！')
        h.add( b)
        b = gtk.Button('删除选中')
        b.connect('clicked', self.scxz)
        tooltips.set_tip(b, '将下面选中频道从收藏中删除！')
        h.add( b)
        v.pack_start( h, expand=False)

        self.modelsc, sw, self.tvsc = self.setTreeView()
        v.add( sw)
        tab.append_page( child=v, tab_label= gtk.Label('收藏'))
        tab.set_size_request( 200, 300)
        
        self.add( tab)
        self.show_all()
        self.catalog_change( menu)
        self.menu = menu

        f = os.path.join( user.home, '.pplive', 'pplive.wdsc')
        if os.path.exists( f):
            ff = open( f)
            line = ff.read().split('\n')
            ff.close()
            line = [ i.strip() for i in line if i.strip()!='' ]
            for i in line:
                l = i.split(';')
                if len(l)==2:
                    iter = self.modelsc.append()
                    self.modelsc.set( iter, 0, l[0], 1, l[1])
        else:
            open( f, 'w+').close()

    def jrsc(self, w):
        if hasattr( self, 'play_url') and hasattr( self, 'play_name'):
            iter = self.modelsc.append()
            self.modelsc.set( iter, 0, self.play_name, 1, self.play_url)
            f = os.path.join( user.home, '.pplive', 'pplive.wdsc')
            ff = open( f, 'r+')
            ff.seek(0,2)
            ff.write( self.play_name + ';' + self.play_url + '\n')
            ff.close()

    def scxz(self, w):
        model,iter = self.tvsc.get_selection().get_selected()
        if iter:
            model.remove( iter)
            f = os.path.join( user.home, '.pplive', 'pplive.wdsc')
            ff = open( f, 'w+')
            for i in model:
                ff.write( i[0] + ';' + i[1] + '\n')
            ff.close()

    def update(self, w):
        furl = os.path.join( user.home, '.pplive', 'pplive.url')
        l = open( furl).read()
        ppurl = l.split('\n')
        ppurl = [ i.strip() for i in ppurl if i.strip()!='' ]

        if len(ppurl)==0:
            self.ppurl = ''
            self.run()
            return

        dia = gtk.Dialog(title='totem pplive plugin 请选择更新',parent=None, flags=0, buttons=None)
        fra = gtk.Frame('pplive.url列表')
        fra.set_border_width(5)
        v = gtk.VBox()
        v.set_border_width(5)

        button = gtk.RadioButton(None, ppurl[0])
        button.connect("toggled", self.url_select)
        button.set_active(True)
        self.ppurl = ppurl[0]
        v.add( button)

        for i in ppurl[1:]:
            button = gtk.RadioButton(button, i)
            button.connect("toggled", self.url_select)
            v.add( button)
        fra.add( v)
        dia.vbox.add( fra)
        b = gtk.Button('确定')
        b.connect('clicked', lambda w,*data: dia.destroy())
        dia.action_area.add(b)
        dia.connect('destroy', self.run)
        dia.show_all()

    def url_select(self, w, *data):
        if w.get_active():
            self.ppurl=w.get_label()

    def run(self, *w):
        f = os.path.join( user.home, '.pplive', 'pplive.list')
        if self.ppurl=='':os.system('wget http://list.pplive.com/zh-cn/xml/new.xml -O %s'%f)
        else:os.system('wget "%s" -O %s'%(self.ppurl,f))
        for i,ii in self.d.items():
            self.menu.remove_text(0)
        self.d = pplive.test()
        for i,ii in self.d.items():
            self.menu.append_text(i)
        self.menu.set_active(0)
        self.catalog_change( self.menu)

    def __create_option_menu(self, options):

        option_menu = gtk.combo_box_new_text()
        for opt in options:
            option_menu.append_text(opt)

        option_menu.set_active(0)
        return option_menu

    def catalog_change(self, w):
        def get_active_text(combobox):
            model = combobox.get_model()
            active = combobox.get_active()
            if active < 0:
                return None
            return model[active][0]
        #print get_active_text(w)
        t = get_active_text(w)
        if self.d=={} or t==None:
            return
        self.catalog = t
        gobject.idle_add( self.setdata, t, 0, 100) 

    def setdata(self, id, ym, ymcount):
        if self.catalog != id:
            return
        if ym==0:
            iter = self.model.get_iter_first()
            while iter:
                self.model.remove( iter)
                iter = self.model.get_iter_first()
            gobject.idle_add( self.setdata, id, ym+1, ymcount) 
            return
        min = (ym-1)*ymcount
        max = ym *ymcount -1
        finish = False
        if max > len(self.d[unicode( id)]):
            max = len(self.d[unicode( id)])
            finish = True

        for i in self.d[unicode( id)][ min: max]:
            iter = self.model.append()
            self.model.set( iter, 0, i['channelname'], 1, i['playlink'])
        
        if not finish:
            gobject.idle_add( self.setdata, id, ym+1, ymcount) 


    def setTreeView(self):
        (COL_NUM, COL_URL) = range(2)
        model = gtk.ListStore(str, str)

        treeview = gtk.TreeView(model)
        treeview.connect("row-activated", self.on_active)
        treeview.get_selection().set_mode(gtk.SELECTION_SINGLE)
        treeview.set_rules_hint(True)

        scroll = gtk.ScrolledWindow()
        scroll.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        scroll.set_shadow_type(gtk.SHADOW_ETCHED_IN)
        scroll.add( treeview)

        renderer = gtk.CellRendererText()
        renderer.set_data("column", COL_NUM)
        column = gtk.TreeViewColumn("频道列表", renderer, text=COL_NUM)
        column.set_resizable(True)
        treeview.append_column(column)

        return model, scroll, treeview

    def on_active (self, tv, path, view_column):
        wdir = os.path.join( user.home, '.pplive')
        model = tv.get_model()
        iter = model.get_iter(path)
        self.play_url = model.get_value(iter, 1)
        self.play_name = model.get_value(iter, 0)
        self.label.set_text( '正在播放：'+self.play_name)
        os.system('killall xpplive;cd %s;xpplive %s &'%( wdir,self.play_url))
        time.sleep(10)
        self.play()

    def play(self, w=None):
        id=os.popen('lsof -i -n -P | grep xpplive |grep LISTEN | grep `whoami`| grep "\*:[0-9]\{4,4\} "').read()
        id=re.findall(r'TCP \*:(\d{4}) \(LISTEN\)', id)
        os.system('mplayer http://127.0.0.1:%s/ -cache 1000 &'%id[0])

if __name__ =='__main__':
    main_window()
    gtk.main()
